From 4df52eee2b40244ba1a3d115a43ed51cfd742105 Mon Sep 17 00:00:00 2001
From: Andy Shaw <andy.shaw@qt.io>
Date: Thu, 7 Feb 2019 17:35:51 +0100
Subject: [PATCH] Menu: account for the scale when getting the size before
 positioning

Fixes: QTBUG-73687
Change-Id: Id2d6a6b5c6651337ab7ae26d07011160b79654bf
Reviewed-by: Mitch Curtis <mitch.curtis@qt.io>
---
 src/quicktemplates2/qquickpopup.cpp           |  1 +
 src/quicktemplates2/qquickpopuppositioner.cpp | 14 +++++++-------
 3 files changed, 17 insertions(+), 15 deletions(-)

diff --git a/src/quicktemplates2/qquickpopup.cpp b/src/quicktemplates2/qquickpopup.cpp
index ecb2568ed..d108420ea 100644
--- a/src/quicktemplates2/qquickpopup.cpp
+++ b/src/quicktemplates2/qquickpopup.cpp
@@ -471,6 +471,7 @@ void QQuickPopupPrivate::finalizeEnterTransition()
     if (focus)
         popupItem->setFocus(true);
     transitionState = NoTransition;
+    getPositioner()->reposition();
     emit q->openedChanged();
     emit q->opened();
 }
diff --git a/src/quicktemplates2/qquickpopuppositioner.cpp b/src/quicktemplates2/qquickpopuppositioner.cpp
index ebd8ff294..dbe8ac1d5 100644
--- a/src/quicktemplates2/qquickpopuppositioner.cpp
+++ b/src/quicktemplates2/qquickpopuppositioner.cpp
@@ -108,10 +108,11 @@ void QQuickPopupPositioner::reposition()
         return;
     }
 
-    const qreal w = popupItem->width();
-    const qreal h = popupItem->height();
-    const qreal iw = popupItem->implicitWidth();
-    const qreal ih = popupItem->implicitHeight();
+    const qreal scale = popupItem->scale();
+    const qreal w = popupItem->width() * scale;
+    const qreal h = popupItem->height() * scale;
+    const qreal iw = popupItem->implicitWidth() * scale;
+    const qreal ih = popupItem->implicitHeight() * scale;
 
     bool widthAdjusted = false;
     bool heightAdjusted = false;
@@ -257,10 +258,9 @@ void QQuickPopupPositioner::reposition()
     }
 
     if (!p->hasWidth && widthAdjusted && rect.width() > 0)
-        popupItem->setWidth(rect.width());
+        popupItem->setWidth(rect.width() / scale);
     if (!p->hasHeight && heightAdjusted && rect.height() > 0)
-        popupItem->setHeight(rect.height());
-
+        popupItem->setHeight(rect.height() / scale);
     m_positioning = false;
 }
 
-- 
2.16.3
